'use strict';

class HttpAgent {
    
    constructor(server, delegate){
        this.server = server;
        this.delegate = delegate;
    }

    start(){
        if( this.server ){
            console.log('HTTP AGENT (WARN): The application is already running!');
        }
        
        this.server = this.delegate.listen();
    }

    stop(cb){
        this.server.close(cb || function(){
            console.log('HTTP AGENT (INFO): The application was stopped, gracefully!');
        });
    }

    restart(cb){
        if( this.status() === 'STOPPED' || this.status() === 'OFFLINE' ){
            this.start();
        }else{
            this.stop(function(){
                this.start();
                (cb || function(){})();
            }.bind(this));
        }
    }

    status(){
        if( this.server === null ){
            return 'OFFLINE';
        }else if( this.server.address() === null ){
            return 'STOPPED';
        }else{
            return 'RUNNING';
        }
    }
}
